<?php

namespace Drupal\backup_migrate_aws_s3\Controller;

use Drupal\backup_migrate\Drupal\Destination\DrupalBrowserDownloadDestination;
use Drupal\backup_migrate\Entity\Destination;
use Drupal\backup_migrate_aws_s3\Destination\AWSS3Destination;
use Drupal\Core\Controller\ControllerBase;

/**
 * @package Drupal\backup_migrate_aws_s3\Controller
 */
class AWSS3BackupController extends ControllerBase {

  /**
   * @var \Drupal\backup_migrate\Core\Destination\DestinationInterface
   */
  public $destination;

  /**
   * Download a backup via the browser.
   *
   * @param \Drupal\backup_migrate\Entity\Destination $backup_migrate_destination
   * @param string $backup_id
   *
   * @return \Symfony\Component\HttpFoundation\Response|void
   *
   * @throws \Drupal\backup_migrate\Core\Exception\BackupMigrateException
   */
  public function download(Destination $backup_migrate_destination, string $backup_id) {
    $destination = $backup_migrate_destination->getObject();
    $file = $destination->getFile($backup_id);

    if ($destination instanceof AWSS3Destination) {
      return $destination->downloadFile($file);
    } else {
      $file = $destination->loadFileForReading($file);
      $browser = new DrupalBrowserDownloadDestination();
      $browser->saveFile($file);
    }
  }

}
